package fishrungames.bashgid;

import java.util.ArrayList;

import fishrungames.bashgid.core.ImageManager;
import fishrungames.bashgid.core.NewsManager;
import fishrungames.bashgid.core.NewsManager.NewsRecord;
import fishrungames.bashgid.core.NewsManager.NewsUpdatedCallbackInterface;
import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;
import it.sephiroth.android.library.widget.HListView;

public class MainPageFragment extends Fragment implements NewsUpdatedCallbackInterface {
	
	
	String [] teaserHeaderArray = { "Для инвестора", "Культура Башкортостана", "Для гостей и туристов", "Образование" };
	
	String [] investorGroupTitleArray = { "Предприятия Башкортостана", "Статистика", "Помощь инвестору", "Транспорт" };
	String [] investorGroupSubtitleArray = { "Обзор", "Все об экономике Башкортостана", "Программа помощи инвесторам", "Обзор транспортной инфраструктуры" };
	int[] investorGroupImgIdArray = { R.drawable.img_for_investor1_button, R.drawable.img_for_investor2_button, R.drawable.img_for_investor3_button, R.drawable.img_for_investor4_button };
	
	
	String [] cultureGroupTitleArray = { "Земфира", "Башкирский театр", "Национальная библиотека" };
	String [] cultureGroupSubtitleArray = { "Персона дня", "Культурные традиции", "Литература"};
	int[] cultureGroupImgIdArray = { R.drawable.img_culture1_button, R.drawable.img_culture2_button, R.drawable.img_culture3_button };
	
	
	String [] touristGroupTitleArray = { "Панорамы Уфы", "Иремель", "Памятник Салавату Юлаеву", "Ночная жизнь в Уфе" };
	String [] touristGroupSubtitleArray = { "Уфа с высоты птичьего полета", "Природный парк", "Достопримечательность", "Обзор"};
	int[] touristGroupImgIdArray = { R.drawable.img_tourist1_button, R.drawable.img_tourist2_button, R.drawable.img_tourist3_button, R.drawable.img_tourist4_button };
	
	String [] educationGroupTitleArray = { "Учебные заведения Уфы", "УГАТУ", "БГПУ" };
	String [] educationGroupSubtitleArray = { "Обзор", "Университет", "Университет"};
	int[] educationGroupImgIdArray = { R.drawable.img_education1_button, R.drawable.img_education2_button, R.drawable.img_education3_button };
	
	
	ListView listView;
	View header;
	
	NewsManager.RemoveCallbackInterface downloadNewsCanceller = null;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.fragment_main_page, container, false);
			
		listView = (ListView) rootView.findViewById(R.id.listView);
		
		listView.setAdapter(new ListAdapter(getActivity()));
		
		header = inflater.inflate(R.layout.main_page_list_header, null);
		
		RefreshHeader();
		
		downloadNewsCanceller = NewsManager.GetInstance().DownloadNews(this);
		
		listView.addHeaderView(header);
		
		Button moreNewsButton = (Button) header.findViewById(R.id.moreNewsButton);
		
		moreNewsButton.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				MainActivity.getInstance().OpenNewsScreen();
			}
		}
		);

		return rootView;
	}
	
    @Override
	public void onDestroyView()
	{
    	if (downloadNewsCanceller != null)
    	{
    		downloadNewsCanceller.RemoveCallback();
    		downloadNewsCanceller = null;
    	}
		super.onDestroyView();
	}
    
	
	
	private void RefreshHeader()
	{
		
		
		ImageButton news1ImageButton = (ImageButton) header.findViewById(R.id.news1ImageButton);
		ImageButton news2ImageButton = (ImageButton) header.findViewById(R.id.news2ImageButton);
		ImageButton news3ImageButton = (ImageButton) header.findViewById(R.id.news3ImageButton);
		
		Button news1Button = (Button)header.findViewById(R.id.news1Button);
		Button news2Button = (Button)header.findViewById(R.id.news2Button);
		Button news3Button = (Button)header.findViewById(R.id.news3Button);
		
		
		ArrayList<NewsManager.NewsRecord> newsRecordArr = NewsManager.GetInstance().getNews();
		
		if (newsRecordArr.size() > 0)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news1ImageButton, newsRecordArr.get(0).imageId);
			news1Button.setText(newsRecordArr.get(0).title);
			
			news1ImageButton.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(0)));
			news1Button.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(0)));
		}
		else
		{
			news1ImageButton.setImageResource(R.drawable.transparent);
			news1Button.setText(R.string.news_record_not_available);
			news1ImageButton.setOnClickListener(null);
			news1Button.setOnClickListener(null);
		}
		
		if (newsRecordArr.size() > 1)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news2ImageButton, newsRecordArr.get(1).imageId);
			news2Button.setText(newsRecordArr.get(1).title);
			news2ImageButton.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(1)));
			news2Button.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(1)));
		}
		else
		{
			news2ImageButton.setImageResource(R.drawable.transparent);
			news2Button.setText(R.string.news_record_not_available);
			news2ImageButton.setOnClickListener(null);
			news2Button.setOnClickListener(null);
		}
		
		if (newsRecordArr.size() > 2)
		{	
			ImageManager.getInstance().ApplyImageToImageView(news3ImageButton, newsRecordArr.get(2).imageId);
			news3Button.setText(newsRecordArr.get(2).title);
			news3ImageButton.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(2)));
			news3Button.setOnClickListener(new ButtonOnClickListener(newsRecordArr.get(2)));
		}
		else
		{
			news3ImageButton.setImageResource(R.drawable.transparent);
			news3Button.setText(R.string.news_record_not_available);
			news3ImageButton.setOnClickListener(null);
			news3Button.setOnClickListener(null);
		}
	
		
	}
	
	
	public class ListAdapter extends BaseAdapter {
	    private Context mContext;

	    public ListAdapter(Context c) {
	        mContext = c;
	    }

	    public int getCount() {
	        return teaserHeaderArray.length;
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.main_page_list_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView textView = (TextView) view.findViewById(R.id.textView);
	        
	        Button button = (Button) view.findViewById(R.id.button);
	        
	        HListView hListView = (HListView) view.findViewById(R.id.hListView);
	        
	        if (position == 0)
	        {
	        
	        	hListView.setAdapter(new MainPageHListViewAdapters.SimpleElementAdapter(getActivity(), investorGroupTitleArray, investorGroupSubtitleArray, investorGroupImgIdArray));
	        }
	        else if (position == 1)
	        {
	        	hListView.setAdapter(new MainPageHListViewAdapters.SimpleElementAdapter(getActivity(), cultureGroupTitleArray, cultureGroupSubtitleArray, cultureGroupImgIdArray));
	        }
	        else if (position == 2)
	        {
	        	hListView.setAdapter(new MainPageHListViewAdapters.SimpleElementAdapter(getActivity(), touristGroupTitleArray, touristGroupSubtitleArray, touristGroupImgIdArray));
	        }
	        else
	        {
	        	hListView.setAdapter(new MainPageHListViewAdapters.SimpleElementAdapter(getActivity(), educationGroupTitleArray, educationGroupSubtitleArray, educationGroupImgIdArray));
	        }
	        
	        textView.setText(teaserHeaderArray[position]);
	        
	        button.setText(R.string.see_all);

	        return view;
	    }

	}


	@Override
	public void OnNewsUpdated()
	{
		getActivity().runOnUiThread(new Runnable() {

			@Override
			public void run()
			{
				RefreshHeader();
			}
			
		});
	}
	
	public static class ButtonOnClickListener implements OnClickListener
	{
		
		NewsRecord newsRecord;
		
		public ButtonOnClickListener(NewsRecord newsRecord)
		{
			this.newsRecord = newsRecord;
		}

		@Override
		public void onClick(View v)
		{
			MainActivity.getInstance().OpenNewsRecordScreen(newsRecord, MainActivity.TAG_FROM_MAINFRAGMENT_TO_NEWSRECORDFRAGMENT);
		}
		
	}
	
}
